﻿using UnityEngine;
using UnityEngine.UI;
using System.Collections;

public class Ball : MonoBehaviour {

    public AudioClip boing;
    public static Ball instance;
    public Text LevelText;
      
    private Paddle paddle;
    private bool hasStarted = false;
    private Vector3 paddleToBallVector;
    private bool firstBall = true;

    // Use this for initialization
    void Start() {
        paddle = GameObject.FindObjectOfType<Paddle>();
        paddleToBallVector = this.transform.position - paddle.transform.position;
        MakeInstance();
        SetBallPosition();
        if (!LevelText.gameObject.activeSelf) {
            LevelText.gameObject.SetActive(true);
        }
    }

    // Update is called once per frame
    void Update() {
        if (!hasStarted) {
            //Lock the ball relative to the paddle.
            this.transform.position = paddle.transform.position + paddleToBallVector;

            //Waiting for a mouseclick to launch ball.
        if (Input.GetMouseButtonDown(0)) {
            hasStarted = true;
            this.GetComponent<Rigidbody2D>().velocity = new Vector2(2f, 10f);
            LevelText.gameObject.SetActive(false);
            }
        }
    }

    void OnCollisionEnter2D(Collision2D collision) {
        Vector2 tweak = new Vector2(Random.Range(0f, 0.2f), Random.Range(0f, 0.2f));

    }

    void MakeInstance() {
        if (instance == null) {
            instance = this;
        }
    }

    public void SetBallPosition() {
        if (firstBall) {
            paddleToBallVector = this.transform.position - paddle.transform.position;
            firstBall = false;
        }
        hasStarted = false;
    }
}
